package ch.zhaw.projekt2.turnierverwaltung;


import java.io.*;
import java.util.Arrays;
import java.util.List;


public class FileIO {
    private File mainDir;
    private File saves;


    public FileIO(String saveLocation) {
        this.mainDir = new File(saveLocation);
        mainDir.mkdir();
        saves = new File(mainDir, "saves");
        saves.mkdir();
    }

    public List<File> getList() {
        return Arrays.asList(saves.listFiles());
    }

    /**
     *
     * @param tournamentFile
     * @return
     * @throws ClassNotFoundException
     * @throws IOException File not found or not readable.
     */
    public Tournament loadTournament(File tournamentFile) throws ClassNotFoundException, IOException {
        Tournament tournament;
        FileInputStream fileInputStream = new FileInputStream(tournamentFile);
        ObjectInputStream in = new ObjectInputStream(fileInputStream);
        tournament = (Tournament) in.readObject();
        in.close(); //TODO: Evtl Try/finally?
        System.out.println("Read File" + tournament.getName() + ".txt being read from " + saves.getAbsolutePath());
        return tournament;
    }

    public void saveTournament(Tournament tournament) throws IllegalArgumentException {
        File newSave = new File(saves, tournament.getName() + ".txt");
        try {
            newSave.createNewFile();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(newSave));
            out.writeObject(tournament);
            out.close();
            System.out.println("Save File" + tournament.getName() + ".txt being saved to " + saves.getAbsolutePath());

        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}
